# mypy-boto3-resourcegroupstaggingapi

[![PyPI - mypy-boto3-resourcegroupstaggingapi](https://img.shields.io/pypi/v/mypy-boto3-resourcegroupstaggingapi.svg?color=blue)](https://pypi.org/project/mypy-boto3-resourcegroupstaggingapi)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-resourcegroupstaggingapi.svg?color=blue)](https://pypi.org/project/mypy-boto3-resourcegroupstaggingapi)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.ResourceGroupsTaggingAPI 1.16.28](https://boto3.amazonaws.com/v1/documentation/api/1.16.28/reference/services/resourcegroupstaggingapi.html#ResourceGroupsTaggingAPI) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.0.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-resourcegroupstaggingapi](#mypy-boto3-resourcegroupstaggingapi)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `ResourceGroupsTaggingAPI` service.

```bash
python -m pip install boto3-stubs[resourcegroupstaggingapi]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[resourcegroupstaggingapi]` in your environment: `python -m pip install 'boto3-stubs[resourcegroupstaggingapi]'`

Both type checking and auto-complete should work for `ResourceGroupsTaggingAPI` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[resourcegroupstaggingapi]` in your environment: `python -m pip install 'boto3-stubs[resourcegroupstaggingapi]'`

Both type checking and auto-complete should work for `ResourceGroupsTaggingAPI` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[resourcegroupstaggingapi]` in your environment: `python -m pip install 'boto3-stubs[resourcegroupstaggingapi]'`
- Run `mypy` as usual

Type checking should work for `ResourceGroupsTaggingAPI` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[resourcegroupstaggingapi]` in your environment: `python -m pip install 'boto3-stubs[resourcegroupstaggingapi]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ResourceGroupsTaggingAPI` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`ResourceGroupsTaggingAPIClient` provides annotations for `boto3.client("resourcegroupstaggingapi")`.

```python
import boto3

from mypy_boto3_resourcegroupstaggingapi import ResourceGroupsTaggingAPIClient

client: ResourceGroupsTaggingAPIClient = boto3.client("resourcegroupstaggingapi")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ResourceGroupsTaggingAPIClient = session.client("resourcegroupstaggingapi")
```

### Paginators annotations

`mypy_boto3_resourcegroupstaggingapi.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_resourcegroupstaggingapi import ResourceGroupsTaggingAPIClient
from mypy_boto3_resourcegroupstaggingapi.paginator import (
    GetComplianceSummaryPaginator,
    GetResourcesPaginator,
    GetTagKeysPaginator,
    GetTagValuesPaginator,
)

client: ResourceGroupsTaggingAPIClient = boto3.client("resourcegroupstaggingapi")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_compliance_summary_paginator: GetComplianceSummaryPaginator = client.get_paginator("get_compliance_summary")
get_resources_paginator: GetResourcesPaginator = client.get_paginator("get_resources")
get_tag_keys_paginator: GetTagKeysPaginator = client.get_paginator("get_tag_keys")
get_tag_values_paginator: GetTagValuesPaginator = client.get_paginator("get_tag_values")
```







### Typed dictionations

`mypy_boto3_resourcegroupstaggingapi.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_resourcegroupstaggingapi.type_defs import (
    ComplianceDetailsTypeDef,
    DescribeReportCreationOutputTypeDef,
    FailureInfoTypeDef,
    GetComplianceSummaryOutputTypeDef,
    GetResourcesOutputTypeDef,
    GetTagKeysOutputTypeDef,
    GetTagValuesOutputTypeDef,
    PaginatorConfigTypeDef,
    ResourceTagMappingTypeDef,
    ResponseMetadata,
    SummaryTypeDef,
    TagFilterTypeDef,
    TagResourcesOutputTypeDef,
    TagTypeDef,
    UntagResourcesOutputTypeDef,
)

def get_structure() -> ComplianceDetailsTypeDef:
    return {
      ...
    }
```
